#include <gsl/gsl_matrix.h>
#include <gsl/gsl_linalg.h>
#include <gsl/gsl_blas.h>
#include <math.h>
#include <stdio.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include "global.h"

void V0invsamp(int p, int k, gsl_vector *b0, double *phi0, double *phi1, 
	       double *phi2, gsl_matrix *S0inv, double nu, gsl_matrix *V0inv, 
	       gsl_rng * r) {
  int i, signum;

  gsl_matrix *Bmb=  gsl_matrix_calloc (p,k);
  gsl_matrix *B= gsl_matrix_calloc (p,k);
  gsl_vector *b= gsl_vector_alloc(p);
  gsl_matrix *SSE =gsl_matrix_calloc(p,p);
  gsl_matrix *Si =gsl_matrix_calloc(p,p);
  gsl_permutation * P = gsl_permutation_alloc (p);

  for(i = 0; i < p; i++){
    gsl_vector_set(b, i, gsl_vector_get(b0,i));
  }

  for(i = 0; i<k; i++) {
    gsl_matrix_set_col (Bmb, i, b);
    gsl_matrix_set(B,0,i,phi0[i]);
    gsl_matrix_set(B,1,i,phi1[i]);
    gsl_matrix_set(B,2,i,phi2[i]);
  }


  gsl_matrix_sub(Bmb,B);


  /* Bmb=b0-beta */

  gsl_blas_dgemm(CblasNoTrans, CblasTrans, 1, Bmb, Bmb, 0, SSE);
  /* SSE = Bmb Bmb' */

  gsl_matrix_memcpy(Si,S0inv);

  gsl_matrix_add(Si, SSE);  /* Si = Si + SSE */

  gsl_linalg_LU_decomp (Si, P, &signum);  
  gsl_linalg_LU_invert(Si, P, SSE); 

  wishart((double)(k+nu), SSE, p, V0inv, r);


  gsl_matrix_free (Bmb);
  gsl_matrix_free (B);
  gsl_vector_free (b);
  gsl_matrix_free (SSE);
  gsl_matrix_free (Si);
}

