#include <gsl/gsl_matrix.h>
#include <gsl/gsl_permute.h>
#include <gsl/gsl_blas.h>
                                                    
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include "global.h"


void mvn(gsl_vector *mu, gsl_matrix *Sig, int p, double *x, gsl_rng * r) {
  /* returns vector x of length p from MVN(mu,Sig) */

  int i;

  gsl_vector *z= gsl_vector_alloc(p);
  gsl_matrix *sig=gsl_matrix_alloc(3,3);
  gsl_matrix_memcpy(sig,Sig);
  for(i=0; i<p; i++)  gsl_vector_set(z,i,gsl_ran_gaussian(r,1));
  gsl_linalg_cholesky_decomp(sig);  

  gsl_blas_dtrmv(CblasLower, CblasNoTrans, CblasNonUnit, sig, z);

  /* z is now the sample from the MVN dist.with mean 0 */

  for(i=0;i<p;i++) x[i]=gsl_vector_get(z,i)+gsl_vector_get(mu,i);
  gsl_vector_free(z);
  gsl_matrix_free(sig);
}

