#include <stdio.h>
#include <string.h>                                                          
#include <math.h>
#include <stdlib.h>
#include "arms.h"                                                            
#define MATHLIB_STANDALONE 1
#include <Rmath.h>
#include "global.h"

/* updated 1-23 to calculate a new indicator for beta0-2 all in same cluster */

int newind(int i, double *nclus, gsl_matrix *phi,  
	   void *data1, int k, int m, double M ){

  /* function for sampling a new cluster membership */
  
  /*
    i = current observation
    nclus = number in cluster
    phi0-2 = vectors of cluster locations
    data1 = data structure
    k = number of clusters
    like = function for evaluating likelihood
    m = number of augmented phi to include in sample
  */
  double probs[N+m], ll[N+m], probscale[1];
  double llscale[1],kstar;
  beta_vector b;
  int j,ir[1];
  struct data *d;

  d=data1;		
/*   printf("i=%d\n",i); */
  kstar=k;
  d->p->index=i;
  for(j=0;j<(k+m);j++){
    /* calculate log-likelihood  */
    set_beta_vector(&b, gsl_matrix_get(phi,j,0),gsl_matrix_get(phi,j,1),
		   gsl_matrix_get(phi,j,2)) ;
    ll[j] = bilike(b,d);
/*         printf(" %lf \n",(like)(phi[j],d));  */
  }

  llscale[0]=ll[0];
  for(j=1;j<(k+m);j++){
    llscale[0]=max(ll[j],llscale[0]);
  }

  for(j=0;j<(k+m);j++){
/* printf("ll %lf %lf %lf \n",llscale[0],ll[j],ll[j]-llscale[0]); */
    probs[j]=exp(ll[j]-llscale[0]);
  }
  for(j=0;j<k;j++){
    /* calculate probability for choosing one of the first k existing clusters */
    probs[j]=nclus[j]*probs[j];
  }

  /* probability of choosing a new cluster  */
  for(j=k;j<(k+m);j++){
    probs[j]=M/(double)m*probs[j];
  }

 
  /* normalize probs */
  probscale[0]=0;
  for(j=0;j<(k+m);j++){
    probscale[0]+=probs[j];
  }
 
  for(j=0;j<(k+m);j++){
    probs[j]/=probscale[0];
  }
 
  /* sample a new indicator */

  ir[0]=samp(probs, (k+m));
/*   printf("ir = %d\n",ir); */
  return ir[0];
}
